;VTrack.asm  by Robert Rayment  18/4/01

;VB

;   res& = CallWindowProc(ptMCode&, ptBITDATA&, irand&, 2&, OpCode&)
;                                   8           12      16  20        
;'=========================================================
;' Structure for input to mcode for RayCASTER & Plasma
;' PS = ProjSurf(), FS = FloorSurf()
; Public Type BITDATA
;   
;   PSWH As Long            'Width=Height of PS         0 PSWH
;   ptrProjSurf As Long     'Pointer to PS              4 ptPS
;   FSWH As Long            'Width=Height of FS         8 FSWH
;   ptrFloorSurf As Long    'Pointer to FS             12 ptFS
;   
;   LAH As Long             'Look ahead length L       16 LAH        'Input
;   ex As Long              'eye x-coord               20 ex         'Input
;   ey As Long              'eye y-coord               24 ey         'Input
;   TANG As Long            'Track angle 0-359         28 TANG       'Input
;   Collision As Long       '0/1 no/yes collision      32 Collision  'Return
;   
;   zvp As Single           'eye z-coord               36 zvp        'Input
;   zdslope As Single       'Ray slope                 40 zdslope    'Input
;   zslopemult As Single    'Ray slope multiplier      44 zslopemult 'Input
;   zhtmult As Single       'Objects height multiplier 48 zhtmult    'Input
;
; End Type
; Public bmp As BITDATA
;'=========================================================

%macro movab 2		;name & num of parameters
  push dword %2		;2nd param
  pop dword %1		;1st param
%endmacro			;use  movab %1,%2
;Allows eg	movab bmW,[ebx+4]

; INPUT DATA STORE
; Long integers
%define PSWH        [ebp-4]
%define ptPS        [ebp-8]
%define FSWH        [ebp-12]
%define ptFS        [ebp-16]
%define LAH         [ebp-20]
%define ex          [ebp-24]
%define ey          [ebp-28]
%define TANG        [ebp-32]
%define Collision   [ebp-36]

; Singles
%define zvp         [ebp-40]
%define zdslope     [ebp-44]
%define zslopemult  [ebp-48]
%define zhtmult     [ebp-52]
; ----------------------------

;	TEMPORARY VARIABLES
%define i2      [ebp-56]       ; integer 2
%define i360    [ebp-60]       ; integer 360
%define PSWH2   [ebp-64]       ; = PSWH/2

%define zrayang	[ebp-68]       ; =(TANG*2*pi)-PSWH/2
%define xvp     [ebp-72]       ; single x	
%define yvp     [ebp-76]       ; single y
%define C       [ebp-80]       ; Column number

%define xray    [ebp-84]       ; singles
%define yray    [ebp-88]
%define zray    [ebp-92]
%define izray   [ebp-96]       ; integer

%define zdx     [ebp-100]      ; singles 
%define zdy     [ebp-104]
%define zdz     [ebp-108]

%define zvoxscale  [ebp-112]
%define row        [ebp-116]   ; integers

%define ixr     [ebp-120]      
%define iyr     [ebp-124]

%define cul     [ebp-128]      ; color		
%define iht     [ebp-132]      ; height integer

%define Collide [ebp-136]      ; Collision value

%define irand   [ebp-140]      ; Random seed
%define ir255   [ebp-144]      ; Random seed

[bits 32]

	push ebp
	mov ebp,esp
	sub esp,144
	push edi
	push esi
	push ebx

;	LOAD INPUT DATA

	mov ebx,[ebp+8]		; ->BITDATA
	
	movab PSWH,[ebx]
	movab ptPS,[ebx+4]
	movab FSWH,[ebx+8]
	movab ptFS,[ebx+12]
	movab LAH, [ebx+16]
	
	movab ex,       [ebx+20]
	movab ey,       [ebx+24]
	movab TANG,     [ebx+28]
	movab Collision,[ebx+32]
	
	movab zvp,       [ebx+36]
	movab zdslope,   [ebx+40]
	movab zslopemult,[ebx+44]
	movab zhtmult,   [ebx+48]

; ----------------------------
	; GET OpCode&
	mov eax,[ebp+20]
; ----------------------------
	
	cmp eax,0
	jne TestFor1
	
	mov Collide,eax		; No Collision
	
	CALL FloorCAST

	jmp GETOUT
	
TestFor1:
	rcr eax,1
	jnc TestFor2
	
	CALL PLASMA
	CALL SMOOTHING
	CALL BYTESMOOTHING

	jmp GETOUT

TestFor2:

GETOUT:
	
	mov eax,irand
	
	
	pop ebx
	pop esi
	pop edi
	mov esp,ebp
	pop ebp
	RET 16

;###########################################
FloorCAST:
	; Store some constants
	mov eax,2
	mov i2,eax
	mov eax,360
	mov i360,eax
	mov eax,PSWH
	shr eax,1
	mov PSWH2,eax		; PSWH/2
	
	; Calculate zrayang
	fild dword TANG		; TANG
	fild dword i2		; 2,TANG
	fmulp st1			; 2*TANG
	fldpi				; pi,2*TANG
	fmulp st1			; pi*2*TANG
	fild dword PSWH2	; PSWH/2,pi*2*TANG
	fsubp ST1			; st1-st0
	fstp dword zrayang  ; =(TANG*2*pi)-PSWH/2
	
	; Store ex & ey as singles ie xvp, yvp
	fild dword ex		; xvp=ex
	fstp dword xvp
	fild dword ey		; yvp=ey
	fstp dword yvp
	
	; OUTER COLUMN LOOP
	mov ecx,0			; For C = 0 To PSWH - 1

NEXT_COLUMN:

	PUSH ecx
	mov dword C,ecx		; Store C

	; Calc xray,yray,zray
	mov eax,xvp			; xray = xvp
	mov xray,eax
	mov eax,yvp			; yray = yvp
	mov yray,eax
	mov eax,zvp			; zray = zvp
	mov zray,eax

	; Store zray as integer izray
	fld dword zray
	fistp dword izray
		
	; Calc zdy,zdx
	fld dword zrayang	; zrayang
	fild dword C		; C,zrayang
	faddp st1			; zrayang+C
	fild dword i360
	fdivp st1			; ((zrayang+C)/360)
	fsincos				; cos | sin
	fstp dword zdy		; = Cos((zrayang+C)/360)
	fstp dword zdx		; = Sin((zrayang+C)/360)
	
	; Calc zdz
	fild dword i2		; 2
	fld dword zdslope	; zdslope,2
	fld dword zslopemult; zslopemult,zdslope,2 
	fmulp st1			; zslopemult*zdslope,2
	fmulp st1			; zslopemult*zdslope*2
	fstp dword zdz		; zdz = zslopemult*zdslope*2
	
	; Init zvoxscale
	fldz				; 0
	fstp dword zvoxscale; zvoxscale = 0
	
	; Init row
	mov eax,1			; row = 1
	mov row,eax

	; LOOK AHEAD STEPS
	mov ecx,0			; For cstep = 0 To LAH

NEXT_STEP:

	; Find ixr & iyr
	fld dword xray		; xray
	fistp dword ixr		; ixr = Int(xray)
	mov eax,ixr			
	mov edx,FSWH
	dec edx				; edx = FSWH-1
	and eax,edx			
	inc eax
	mov ixr,eax			; = (xray AND (FSWH - 1) + 1
	
	fld dword yray		; yray
	fistp dword iyr		; iyr = Int(yray)
	mov eax,iyr
	and eax,edx
	inc eax
	mov iyr,eax			; = (yray AND (FSWH - 1) + 1

	; Get color/height = FloorSurf(ixr,iyr) ->cul
	; and multiply by zhtmult
	mov esi,ptFS		; -> FloorSurf(1,1)
	mov eax,iyr
	dec eax
	mov edx,FSWH
	mul edx		
	add esi,eax 		; ptFS + (iyr-1) * FSWH
	mov eax,ixr
	dec eax
	add esi,eax			; -> FloorSurf(ixr,iyr)
	
	; Get cul
	xor eax,eax
	mov al,[esi]
	mov cul,eax			; cul in AL
	
	; Multiply by zhtmult
	fild dword cul		; cul
	fld dword zhtmult	; zhtmult,cul
	fmulp ST1
	fistp dword iht		; iht = Int(FloorSurf(ixr,iyr) * zhtmult)
	
	; Compare iht & izray
	mov eax,iht
	cmp eax,izray
	jle near UPDATE_RAY ; iht <= izray

	; zht > zray  -  above drawn area

DRAW_PIX:

	mov edi,ptPS		; ->ProjSurf(1,1)	
	mov eax,row
	dec eax
	mov edx,PSWH
	mul edx
	add edi,eax			; ptPS + (row-1) * PSWH
	mov eax,C
	;inc eax
	add edi,eax			; ->ProjSurf(C+1,row)
	mov eax,cul
	mov [edi],AL		; ProjSurf(C+1,row) = cul
	
	; Update zray
	fld dword zdz
	fld dword zdslope
	faddp st1
	fstp dword zdz		; zdz = zdz + zdslope
	
	fld dword zray
	fld dword zvoxscale
	faddp st1
	fstp dword zray		; zray = zray + zvoxscale
	
	mov eax,row
	inc eax
	mov row,eax			; row = row + 1
	
	cmp eax,PSWH		; row-PSWH
	ja near UPDATE_COLUMN	;row > PSWH
	
	; Test collision
	;---------------
	mov eax,Collide
	cmp eax,1
	je End_Collision    ;Collision already found
	
	mov eax,ex			; eax=ex
	mov edx,ixr
	sub edx,2			; edx=ixr-2
	cmp eax,edx			; ex-(ixr-2)
	jl End_Collision	; ex < ixr-2

	add edx,4			; edx=ixr+2
	cmp eax,edx			; ex-(ixr+2)
	jg End_Collision	; ex > ixr+2
	
	mov eax,ey			; eax=ey
	mov edx,iyr
	sub edx,2			; edx = iyr-2
	cmp eax,edx			; ey-(iyr-2)
	jl End_Collision	; ey < iyr-2

	add edx,4			; edx=iyr+2
	cmp eax,edx			; ey-(iyr+2)
	jg End_Collision	; ey > iyr+2

	mov eax,1
	mov Collide,eax		; A Collision
End_Collision:
	;---------------
	
	fld dword zray	
	fistp dword izray
	mov eax,izray
	cmp eax,iht			; izray-iht
	jle near DRAW_PIX	; izray <= iht
	
	; izray > iht   column done

UPDATE_RAY:
	fld dword zdx
	fld dword xray
	faddp st1
	fstp dword xray		;xray=xray+zdx
	
	fld dword zdy
	fld dword yray
	faddp st1
	fstp dword yray		;yray=yray+zdy
	
	fld dword zdz
	fld dword zray
	faddp st1
	fstp dword zray		;zray=zray+zdz

	; Store zray as integer izray
	fld dword zray
	fistp dword izray

	fld dword zdslope
	fld dword zvoxscale
	faddp st1
	fstp dword zvoxscale	;zvoxscale=zvoxscale+zdslope
	
	inc ecx
	cmp ecx,LAH			; ecx-LAH
	jle near NEXT_STEP	; ecx <= LAH	Next cstep

UPDATE_COLUMN:
	POP ecx
	inc ecx
	mov eax,PSWH
	dec eax				; PSWH-1
	cmp eax,ecx			; (PSWH-1)-C
	jg near NEXT_COLUMN	; (PSWH-1) > C  ie C < (PSWH-1)  Next C
	
	; C = PSWH-1  all columns done

SaveCollision:
	; Return Collision 0/1 no/yes collision
	mov ebx,[ebp+8]		; ->BITDATA
	mov eax,Collide
	mov [ebx+32],eax	; bmp.Collision = Collide
RET

;###########################################
PLASMA:

%define FSWH1		[ebp-56]       ; FSWH-1 for ANDing
%define LEVUP		[ebp-60]       ; LEVUP where FSWH = 2^LEVUP
%define StepSize	[ebp-64]       ; StepSize
%define ix1			[ebp-68]
%define iy1			[ebp-72]
%define ix2			[ebp-76]
%define iy2			[ebp-80]
%define cul1		[ebp-84]
%define cul2		[ebp-88]
%define cul3		[ebp-92]
%define cul4		[ebp-96]
%define ixm			[ebp-100]    
%define iym			[ebp-104]

	mov eax,[ebp-12]
	mov irand,eax
	
	mov esi,ptFS
	CALL RandRough
	mov [esi],al		;FloorSurf(1,1) = Rand 255

	mov eax,FSWH
	dec eax
	mov FSWH1,eax		;FSWH-1  for ANDing

	add esi,eax
	CALL RandRough		;FloorSurf(FSWH,1) = Rand 255
	mov [esi],al

	mov eax,FSWH
	mov edx,FSWH
	dec edx
	mul edx
	add esi,eax
	CALL RandRough
	mov [esi],al		;FloorSurf(FSWH,FSWH) = Rand 255

	mov edx,FSWH
	dec edx
	sub esi,edx
	CALL RandRough
	mov [esi],al		;FloorSurf(1,FSWH) = Rand 255

	; Get power of 2 for FSWH
	mov eax,FSWH
	mov ecx,0
Div2:
	shr eax,1
	jc StartLEV
	inc ecx
	jmp Div2
	
StartLEV:				; ie FSWH = 2 ^ ecx
	mov LEVUP,ecx		; LEVUP where FSWH = 2^LEVUP  {LEVUP=11 OK}

	mov ecx,2			; For Lev = 2 To LEVUP (11 for 2048) 

NEXTLEV:
	PUSH ecx
	mov ebx,1
	shl ebx,CL			; NoSteps = 2 ^ LEV

	xor edx,edx
	mov eax,FSWH
	div ebx
	mov StepSize,eax	; StepSize = FSWH/NoSteps

	mov ebx,1			; For IY = 1 to FSWH + 1 Step StepSize
NEXTIY:
	mov ecx,1			; For IX = 1 to FSWH + 1 Step StepSize
NEXTIX:
	PUSH ecx
	;=========================
	mov eax,ecx			; IX
	mov edx,FSWH1
	and eax,edx
	inc eax				; ix1 = (IX AND FSWH1) + 1
	mov ix1,eax
	
	mov eax,ebx			; IY
	mov edx,FSWH1
	and eax,edx
	inc eax				; iy1 = (IY AND FSWH1) + 1
	mov iy1,eax
	
	mov eax,ecx			; IX
	mov edx,StepSize
	add eax,edx
	mov edx,FSWH1
	and eax,edx
	inc eax				; ix2 = ((IX + StepSize) AND FSWH1) + 1
	mov ix2,eax
	
	mov eax,ebx			; IY
	mov edx,StepSize
	add eax,edx
	mov edx,FSWH1
	and eax,edx
	inc eax				; iy1 = ((IY + StepSize) AND FSWH1) + 1
	mov iy2,eax
	;-------------------------
	;----  cul1
	mov esi,ptFS
	mov eax,iy1
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix1
	dec eax
	add esi,eax
	xor eax,eax
	mov AL,[esi]
	mov cul1,eax
	;----  cul2
	mov esi,ptFS
	mov eax,iy2
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix1
	dec eax
	add esi,eax
	xor eax,eax
	mov AL,[esi]
	mov cul2,eax
	;----  cul3
	mov esi,ptFS
	mov eax,iy1
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix2
	dec eax
	add esi,eax
	xor eax,eax
	mov AL,[esi]
	mov cul3,eax
	;----  cul4
	mov esi,ptFS
	mov eax,iy2
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix2
	dec eax
	add esi,eax
	xor eax,eax
	mov AL,[esi]
	mov cul4,eax
	;-------------------------
	;--- Left ix1
	mov eax,iy1
	add eax,iy2
	shr eax,1
	mov iym,eax
	
	mov eax,cul1
	add eax,cul2
	shr eax,1
	push eax
	CALL RandRough
	pop eax
	add eax,edx
	and eax,0FFh		; culav AND 255
	mov ecx,eax			; ecx = culav AND 255
	mov esi,ptFS
	mov eax,iym
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix1
	dec eax
	add esi,eax
	mov [esi],CL
	
	;--- Right ix2
	mov eax,cul3
	add eax,cul4
	shr eax,1
	push eax
	CALL RandRough
	pop eax
	add eax,edx
	and eax,0FFh		; culav AND 255
	mov ecx,eax			; ecx = culav AND 255
	mov esi,ptFS
	mov eax,iym
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ix2
	dec eax
	add esi,eax
	mov [esi],CL

	;--- Bottom iy1
	mov eax,ix1
	add eax,ix2
	shr eax,1
	mov ixm,eax
	
	mov eax,cul1
	add eax,cul3
	shr eax,1
	push eax
	CALL RandRough
	pop eax
	add eax,edx
	and eax,0FFh		; culav AND 255
	mov ecx,eax			; ecx = culav AND 255
	mov esi,ptFS
	mov eax,iy1
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ixm
	dec eax
	add esi,eax
	mov [esi],CL
	
	;--- Top iy2
	mov eax,cul2
	add eax,cul4
	shr eax,1
	push eax
	CALL RandRough
	pop eax
	add eax,edx
	and eax,0FFh		; culav AND 255
	mov ecx,eax			; ecx = culav AND 255
	mov esi,ptFS
	mov eax,iy2
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ixm
	dec eax
	add esi,eax
	mov [esi],CL

	;--- Center ixm,iym
	mov eax,cul1
	add eax,cul2
	add eax,cul3
	add eax,cul4
	shr eax,2
	push eax
	CALL RandRough
	pop eax
	add eax,edx
	and eax,0FFh		; culav AND 255
	mov ecx,eax			; ecx = culav AND 255
	mov esi,ptFS
	mov eax,iym
	dec eax
	mov edx,FSWH
	mul edx
	add esi,eax
	mov eax,ixm
	dec eax
	add esi,eax
	mov [esi],CL
	
	;=========================
	POP ecx
	mov eax,StepSize
	add eax,ecx
	inc eax				; = ecx + StepSize +1
	cmp eax,FSWH
	jg  TestIY			; ecx + StepSize +1 > FSWH
	dec eax
	mov ecx,eax			; ecx + StepSize
	jmp near NEXTIX

TestIY:
	mov eax,StepSize
	add eax,ebx
	inc eax				; = ecx + StepSize +1
	cmp eax,FSWH
	jg  TestLEV			; ecx + StepSize +1 > FSWH
	dec eax
	mov ebx,eax			; ecx + StepSize
	jmp near NEXTIY

TestLEV:

	POP ecx
	inc ecx
	cmp ecx,LEVUP		; ie ecx-11 (for 2048)
	jle near NEXTLEV
RET

;###########################################
RandRough:

;	Produces 16 * (Rnd - 0.5) in edx

	mov eax,01180Bh		;71699
	imul dword irand
	add eax,0AB209h		;700937
	; Make odd
	rcr eax,1
	jc ok
	stc
ok:
	rcl eax,1
	mov irand,eax
	
	xor edx,edx
	mov dl,al			;0-255
	
	sub dx,128			;-128 -> +128
	sar dx,3			;3 edx =+/- 0->16

RET
;###########################################
SMOOTHING:
	cld					;cause edi to increment with stosd
	mov edi,ptFS
	mov eax,2052
	add edi,eax
	mov ecx,1047548  ;9
	
	pxor mm7,mm7
	movd mm0,[edi-4]
Smooth:
	movd mm1,[edi+4]
	movd mm2,[edi-2048]
	movd mm3,[edi+2048]
	
	punpcklbw mm0,mm7
	punpcklbw mm1,mm7
	punpcklbw mm2,mm7
	punpcklbw mm3,mm7
	
	paddusw mm0,mm1
	paddusw mm0,mm2
	paddusw mm0,mm3
	
	psrlw mm0,2
	
	packuswb mm0,mm7
	
	movd eax,mm0
	
	stosd
	
	sub ecx,4
	jnz Smooth
	emms
RET
;###########################################
BYTESMOOTHING:

MOV ecx,5

NSmoothers:

PUSH ecx

	; BL corner
	mov edi,ptFS
	xor edx,edx
	mov AL,[edi+2048]
	add edx,eax
	mov AL,[edi+1]
	add edx,eax
	shr edx,1
	mov [edi],DL
	
	; Bottom line
	mov eax,2047
	mov ebx,2048
	mul ebx			; Byte span top to bottom
	mov ebx,eax  
	
	mov ecx,2046
NextBLine:
	xor edx,edx
	mov AL,[edi-1]
	add edx,eax
	mov AL,[edi+1]
	add edx,eax
	mov AL,[edi+ebx]
	add edx,eax
	inc ebx
	mov AL,[edi+ebx]
	dec ebx
	add edx,eax
	shr edx,2
	mov [edi],DL
	inc edi
	dec ecx
	jnz NextBLine
	
	mov edi,ptFS
	inc edi
	mov eax,2048
	add edi,eax
	mov ecx,4190204
	xor eax,eax

ByteSmooth:
	xor edx,edx
	mov AL,[edi-1]
	add edx,eax
	mov AL,[edi+1]
	add edx,eax
	mov AL,[edi-2048]
	add edx,eax
	mov AL,[edi+2048]
	add edx,eax
	shr edx,2
	mov [edi],DL
	inc edi
	dec ecx
	jnz ByteSmooth

	; TR corner
	xor edx,edx
	mov AL,[edi+2047]
	add edx,eax
	mov AL,[edi]
	add edx,eax
	shr edx,1
	mov [edi+2048],DL
	
	add edi,2047	; TL corner -1
	neg ebx
	mov ecx,2046
NextTLine:
	xor edx,edx
	mov AL,[edi+1]
	add edx,eax
	mov AL,[edi-1]
	add edx,eax
	mov AL,[edi+ebx]
	add edx,eax
	dec ebx
	mov AL,[edi+ebx]
	inc ebx
	add edx,eax
	shr edx,2
	mov [edi],DL
	dec edi
	dec ecx
	jnz NextTLine
	
	; TL corner
	xor edx,edx
	mov AL,[edi+2049]
	add edx,eax
	mov AL,[edi]
	add edx,eax
	shr edx,1
	mov [edi+2048],DL

POP ecx
dec ecx
jnz near NSmoothers


RET
;###########################################
;;;;;;;;;;;;;;;;;;;;
;pop ecx
;mov eax,ebx 
;RET
;;;;;;;;;;;;;;;;;;;;


